import java.awt.*;
import java.awt.image.*;
import java.awt.image.ImageObserver;
import java.awt.event.*;
import java.util.*;
import java.applet.*;

public class maya1 extends java.applet.Applet implements Runnable, MouseListener, MouseMotionListener  {
	Image		  	Buffer;
	MemoryImageSource 	Bufms;
	DirectColorModel	dcm;
	int			buf[];
	int			plane0[];
	int			mx = 100, my = 100;
	
	int			NUMPARTICLES = 200;
	int 		NUMNODES = 4;
	
	Thread	runner = null;
	
	//int			distance[][];
	int 		width = 600; 
	int 		height = 300;
	int			wh = width*height;
	int			bgcol;
	
	particle			p[];
	node					n[];
	
  public void init() {
		buf = new int[wh];		
		plane0 = new int[wh];
		
		/*
		distance = new int[width][height];
		for(int i=0;i<width;i++) {
			for(int j=0;j<height;j++) {
				distance[i][j] = (int)(Math.sqrt((i*i) + (j*j)));
				}
			}
		*/
		
		p = new particle[NUMPARTICLES];
		n = new node[NUMNODES];
		
		dcm=new DirectColorModel(24,0x00FF0000,0x0000FF00,0x000000FF);
		Bufms=new MemoryImageSource(width, height,dcm,buf,0,width);
		Bufms.setAnimated(true);
		Bufms.setFullBufferUpdates(true);
		
		Buffer=createImage(Bufms);
		bgcol = 0x00ffffff;

		// create nodes
		for(int i=0;i<NUMNODES;i++) {
			int x = (int)(Math.random()*width);
			int y = (int)(Math.random()*height-1);
			n[i] = new node(x,y);
			}
		
		// create particles
		for(int i=0;i<NUMPARTICLES;i++) {
			int x = (int)(Math.random()*width);
			int y = (int)(Math.random()*height-1);	
			double xvel = Math.random()*12-6;
			double yvel = Math.random()*12-6;
			
			int nodeid = (int)(Math.random()*NUMNODES);
			int targx = n[nodeid].x;
			int targy = n[nodeid].y;
			
			p[i] = new particle(x,y,xvel,yvel,targx, targy, nodeid,0);
			}
		
		for(int i=0;i<wh;i++) {
			buf[i] = bgcol;
			plane0[i] = bgcol;
			}
		
		addMouseListener(this);
    addMouseMotionListener(this);
		}


	public void drawline(int x0, int y0, int x1, int y1, int pix, int buffer[]) {
		if(x0 < 0 || x0 >= width || y0 < 0 || y0 >= height || x1 < 0 || x1 >= width || y1 < 0 || y1 >= height) return;
		
		int dy = y1 - y0;
		int dx = x1 - x0;
		int stepx, stepy;
		
		if (dy < 0) { dy = -dy;  stepy = -width; } else { stepy = width; }
		if (dx < 0) { dx = -dx;  stepx = -1; } else { stepx = 1; }
		dy <<= 1;
		dx <<= 1;
		
		y0 *= width;
		y1 *= width;
		//modpixel(x0+y0, pix, buffer);
		
		if (dx > dy) {
			int fraction = dy - (dx >> 1);
			while (x0 != x1) {
				if (fraction >= 0) {
					y0 += stepy;
					fraction -= dx;
					}
				x0 += stepx;
				fraction += dy;
				modpixel(x0+y0, pix, buffer);
				}
			} 
		
		else {
			int fraction = dx - (dy >> 1);
			while (y0 != y1) {
				if (fraction >= 0) {
					x0 += stepx;
					fraction -= dy;
					}
				y0 += stepy;
				fraction += dx;
				modpixel(x0+y0, pix, buffer);
				}
			}
		}

	private void modpixel(int pos, int col, int buffer[]) {
		//int alp=247;
		int alp=245;
		//if(pos >= wh) return;
		int r1=(buffer[pos])&0x0000ff;
		int g1=(buffer[pos])&0x00ff00;
		int b1=(buffer[pos])&0xff0000;
		int r2=(col)&0x0000ff;
		int g2=(col)&0x00ff00;
		int b2=(col)&0xff0000;
		int r3=(((alp*(r1-r2))>>8)+r2)&0x000000ff;
		int g3=(((alp*(g1-g2))>>8)+g2)&0x0000ff00;
		int b3=(((alp*(b1-b2))>>8)+b2)&0x00ff0000;
		buffer[pos]=(r3)|(g3)|(b3);
		}
	
	public void paint (Graphics g){
		update(g);
		}

	public void update (Graphics g){
		/*
		for(int i=1; i<wh; i++) {
			int alp=251;
			int r1=(buf[i])&0x0000ff;
			int g1=(buf[i])&0x00ff00;
			int b1=(buf[i])&0xff0000;
			int r2=(plane0[i])&0x0000ff;
			int g2=(plane0[i])&0x00ff00;
			int b2=(plane0[i])&0xff0000;
			int r3=(((alp*(r1-r2))>>8)+r2)&0x000000ff;
			int g3=(((alp*(g1-g2))>>8)+g2)&0x0000ff00;
			int b3=(((alp*(b1-b2))>>8)+b2)&0x00ff0000;
			buf[i]=(r3)|(g3)|(b3);
			}
		*/
		for(int i = 0; i < NUMPARTICLES; i++) {
			p[i].updatepos();
			if(p[i].target == -1) {
				int nodeid = (int)(Math.random()*NUMNODES);
				p[i].targx = n[nodeid].x;
				p[i].targy = n[nodeid].y;
				p[i].target = nodeid;
				}
			drawline((int)p[i].x, (int)p[i].y, (int)p[i].lastx, (int)p[i].lasty,0x00000000, buf);
			}
		
		Bufms.newPixels();
		g.drawImage(Buffer,0,0,this);
		}

  public void mouseDragged(MouseEvent e) {  }
  public void mouseClicked(MouseEvent e) {	}
  public void mouseEntered(MouseEvent e) {  }
  public void mouseExited(MouseEvent e) {  }
  public void mousePressed(MouseEvent e) {  }
  public void mouseReleased(MouseEvent e) { }
  
  public void mouseMoved(MouseEvent e) {
    mx = e.getX();
    my = e.getY();
  	}

	public void run(){
		while(runner != null) {
			repaint();
			}
		}

  public void start() {
  	if(runner == null) {
			runner = new Thread();
			runner.start();
			}
  	}
  	
  public void stop() {
  	System.out.println("Stopping...");
  	runner = null;
  	}	
  }